## croaring 0.2.63+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
include(GNUInstallDirs)

set(CMAKE_MACOSX_RPATH OFF)
if (NOT CMAKE_BUILD_TYPE)
                message(STATUS "No build type selected, default to Release")
                set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
endif()

project(RoaringBitmap)
set(ROARING_LIB_NAME roaring)
set(PROJECT_VERSION_MAJOR 0)
set(PROJECT_VERSION_MINOR 2)
set(PROJECT_VERSION_PATCH 63)
set(ROARING_LIB_VERSION "0.2.63" CACHE STRING "Roaring library version")
set(ROARING_LIB_SOVERSION "0" CACHE STRING "Roaring library soversion")

option(ROARING_DISABLE_X64 "Forcefully disable x64 optimizations even if hardware supports it (this disables AVX) " OFF)
option(ROARING_DISABLE_AVX "Forcefully disable AVX even if hardware supports it" OFF)
option(ROARING_DISABLE_NEON "Forcefully disable NEON even if hardware supports it" OFF)
option(ROARING_DISABLE_NATIVE "Forcefully disable -march optimizations" OFF)
set(ROARING_ARCH "native" CACHE STRING "If ROARING_DISABLE_NATIVE is OFF, the architecture to optimize for (-march)")

IF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")
SET(ROARING_DISABLE_AVX ON) # for ARM processors, there is no hope of having AVX support
SET(ROARING_DISABLE_NATIVE ON) # ARM platforms may not like -march=native
ENDIF(${CMAKE_SYSTEM_PROCESSOR} MATCHES "arm")

if(${CMAKE_SYSTEM_PROCESSOR} MATCHES "aarch64")
SET(ROARING_DISABLE_AVX ON) # for ARM processors, there is no hope of having AVX support
SET(ROARING_DISABLE_NATIVE ON) # ARM platforms may not like -march=native
endif()

option(ROARING_BUILD_STATIC "Build a static library" OFF) # turning it on disables the production of a dynamic library
option(ROARING_LINK_STATIC "Link executables (tests, benchmarks) statically" OFF)
option(ROARING_BUILD_LTO "Build library with Link Time Optimization" OFF)
option(ROARING_SANITIZE "Sanitize addresses" OFF)
option(ENABLE_ROARING_TESTS "If OFF, disable unit tests altogether" ON)

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/tools/cmake")

find_package(CTargets)
find_package(Options)
find_package(LTO)

## C header files get installed to /usr/local/include/roaring typically
install(DIRECTORY include/${ROARING_LIB_NAME} DESTINATION include)

####
### Some users want the C++ header files to be installed as well.
### C++ header files get installed to /usr/local/include/roaring typically
SET(CPP_ROARING_HEADERS cpp/roaring64map.hh  cpp/roaring.hh) # needs to be updated if we add more files
install(FILES ${CPP_ROARING_HEADERS} DESTINATION include/${ROARING_LIB_NAME})


enable_testing()
include(CTest)

##################################
#### My understanding is that variable get passed down to subdirectories, so
#### this needs to be done here.
set (TEST_DATA_DIR "${CMAKE_CURRENT_SOURCE_DIR}/tests/testdata/")
set (BENCHMARK_DATA_DIR "${CMAKE_CURRENT_SOURCE_DIR}/benchmarks/realdata/")
MESSAGE( STATUS "BENCHMARK_DATA_DIR: " ${BENCHMARK_DATA_DIR} )
MESSAGE( STATUS "TEST_DATA_DIR: " ${TEST_DATA_DIR} )
configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/tests/config.h.in"
                "${CMAKE_CURRENT_SOURCE_DIR}/tests/config.h")
#################################

add_subdirectory(src)
if(ENABLE_ROARING_TESTS)
  add_subdirectory(benchmarks)
  add_subdirectory(tests)
endif()
# Being terse is good, but knowing how the build is configured is important
# and should not be hard to figure out.
MESSAGE( STATUS "CMAKE_SYSTEM_PROCESSOR: " ${CMAKE_SYSTEM_PROCESSOR})
MESSAGE( STATUS "CMAKE_BUILD_TYPE: " ${CMAKE_BUILD_TYPE} ) # this tends to be "sticky" so you can remain unknowingly in debug mode
MESSAGE( STATUS "ROARING_DISABLE_X64: " ${ROARING_DISABLE_X64} ) # options in cmake are "sticky" so old options can remain even if that is counterintuitive
MESSAGE( STATUS "ROARING_DISABLE_AVX: " ${ROARING_DISABLE_AVX} ) # options in cmake are "sticky" so old options can remain even if that is counterintuitive
MESSAGE( STATUS "ROARING_DISABLE_NEON: " ${ROARING_DISABLE_NEON} )
MESSAGE( STATUS "ROARING_DISABLE_NATIVE: " ${ROARING_DISABLE_NATIVE} )
MESSAGE( STATUS "ROARING_ARCH: " ${ROARING_ARCH} )
MESSAGE( STATUS "ROARING_BUILD_STATIC: " ${ROARING_BUILD_STATIC} )
MESSAGE( STATUS "ROARING_LINK_STATIC: " ${ROARING_LINK_STATIC} )
MESSAGE( STATUS "ROARING_BUILD_LTO: " ${ROARING_BUILD_LTO} )
MESSAGE( STATUS "ROARING_SANITIZE: " ${ROARING_SANITIZE} )
MESSAGE( STATUS "CMAKE_C_COMPILER: " ${CMAKE_C_COMPILER} ) # important to know which compiler is used
MESSAGE( STATUS "CMAKE_C_FLAGS: " ${CMAKE_C_FLAGS} ) # important to know the flags
MESSAGE( STATUS "CMAKE_C_FLAGS_DEBUG: " ${CMAKE_C_FLAGS_DEBUG} )
MESSAGE( STATUS "CMAKE_C_FLAGS_RELEASE: " ${CMAKE_C_FLAGS_RELEASE} )


set(CPACK_PACKAGE_VENDOR "Daniel Lemire")
set(CPACK_PACKAGE_CONTACT "lemire@gmail.com")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Roaring bitmaps in C")
set(CPACK_PACKAGE_VERSION_MAJOR ${PROJECT_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${PROJECT_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${PROJECT_VERSION_PATCH})
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README.md")

set(CPACK_RPM_PACKAGE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set(CPACK_SOURCE_GENERATOR "TGZ;ZIP")
include(CPack)

=== src/CMakeLists.txt ===
if(${CMAKE_C_COMPILER_ID} MATCHES "Intel") # icc / icpc
  # prevent shared libraries from depending on Intel provided libraries
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -static-intel")
endif()


# we default on a shared library.
if(ROARING_BUILD_STATIC)
  set(ROARING_LIB_TYPE STATIC)
  MESSAGE( STATUS "Building a static library." )
else()
  MESSAGE( STATUS "Building a dynamic library (default)." )
  set(ROARING_LIB_TYPE SHARED)
endif()

MESSAGE( STATUS "ROARING_LIB_TYPE: " ${ROARING_LIB_TYPE})
set(ROARING_SRC
    array_util.c
    bitset_util.c
    containers/array.c
    containers/bitset.c
    containers/containers.c
    containers/convert.c
    containers/mixed_intersection.c
    containers/mixed_union.c
    containers/mixed_equal.c
    containers/mixed_subset.c
    containers/mixed_negation.c
    containers/mixed_xor.c
    containers/mixed_andnot.c
    containers/run.c
    roaring.c
    roaring_priority_queue.c
    roaring_array.c)

add_library(${ROARING_LIB_NAME} ${ROARING_LIB_TYPE} ${ROARING_SRC})
target_include_directories(${ROARING_LIB_NAME}
  PUBLIC
   $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

#
#install(TARGETS ${ROARING_LIB_NAME} DESTINATION lib)
#
install(TARGETS ${ROARING_LIB_NAME}
   EXPORT ${ROARING_LIB_NAME}-config
   ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
   LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
   RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

install(EXPORT ${ROARING_LIB_NAME}-config
   FILE ${ROARING_LIB_NAME}-config.cmake
   NAMESPACE ${ROARING_LIB_NAME}::
   DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${ROARING_LIB_NAME}
 )

if(NOT MSVC)
## We output the library at the root of the current directory where cmake is invoked
## This is handy but Visual Studio will happily ignore us
set_target_properties(${ROARING_LIB_NAME} PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
  VERSION ${ROARING_LIB_VERSION}
  SOVERSION ${ROARING_LIB_SOVERSION})
MESSAGE( STATUS "Library output directory (does not apply to Visual Studio): " ${CMAKE_BINARY_DIR})
endif()

if(MSVC AND (ROARING_LIB_TYPE STREQUAL "SHARED"))
  if (CMAKE_VERSION VERSION_LESS 3.4)
    MESSAGE( STATUS "To build  a Windows DLL using Visual Studio, you may need cmake 3.4 or better." )
  endif()
  MESSAGE( STATUS "Building a Windows DLL using Visual Studio, exporting all symbols automatically." )
 set_target_properties(${ROARING_LIB_NAME}
    PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS 1)
endif()

=== debian/changelog ===
croaring (0.2.63+ds-2) unstable; urgency=medium

  * d/libroaring-dev: Fix subdirs installation.
  * Add 001-containerptr_roaring_bitmap_add-public.patch

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 30 Jun 2019 21:08:52 +0300

croaring (0.2.63+ds-1) unstable; urgency=low

  * Initial release (Closes: #931289)

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 30 Jun 2019 19:56:12 +0300

=== debian/control ===
Source: croaring
Priority: optional
Maintainer: Alexander GQ Gerasiov <gq@debian.org>
Build-Depends: debhelper (>= 11), cmake
Standards-Version: 4.3.0
Section: libs
Homepage: https://github.com/RoaringBitmap/CRoaring
Vcs-Git: https://salsa.debian.org/debian/croaring.git
Vcs-Browser: https://salsa.debian.org/debian/croaring.git

Package: libroaring-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libroaring0 (= ${binary:Version})
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Portable Roaring bitmaps in C (and C++) (headers)
 Bitsets, also called bitmaps, are commonly used as fast data structures.
 Unfortunately, they can use too much memory. To compensate, we often use
 compressed bitmaps.
 Roaring bitmaps are compressed bitmaps which tend to outperform conventional
 compressed bitmaps such as WAH, EWAH or Concise.
 .
 This package provides library headers.

Package: libroaring0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Portable Roaring bitmaps in C (and C++)
 Bitsets, also called bitmaps, are commonly used as fast data structures.
 Unfortunately, they can use too much memory. To compensate, we often use
 compressed bitmaps.
 Roaring bitmaps are compressed bitmaps which tend to outperform conventional
 compressed bitmaps such as WAH, EWAH or Concise.

## croaring 0.2.65%2Bds

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
   set(ROARING_LIB_TYPE STATIC)
   MESSAGE( STATUS "Building a static library." )
 else()
-  MESSAGE( STATUS "Building a dynamic library (default)." )
+  MESSAGE( STATUS "Building a dynamic library." )
   set(ROARING_LIB_TYPE SHARED)
 endif()

=== debian/changelog ===
croaring (0.2.65+ds-1) unstable; urgency=medium

  * New upstream version 0.2.65+ds
  * d/libroaring0.symbols.amd64: Add forgotten #include.

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 20 Oct 2019 17:35:34 +0300

croaring (0.2.63+ds-3) unstable; urgency=medium

  * debian/libroaring0.symbols*: Fix FTBTS on arch other then amd64.
  * d/control: Fix libcroaring-dev deprends on ${shlibs:Depends}.

 -- Alexander GQ Gerasiov <gq@debian.org>  Wed, 21 Aug 2019 19:03:33 +0300

## croaring 0.2.65+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,8 @@
 set(ROARING_LIB_NAME roaring)
 set(PROJECT_VERSION_MAJOR 0)
 set(PROJECT_VERSION_MINOR 2)
-set(PROJECT_VERSION_PATCH 63)
-set(ROARING_LIB_VERSION "0.2.63" CACHE STRING "Roaring library version")
+set(PROJECT_VERSION_PATCH 65)
+set(ROARING_LIB_VERSION "0.2.65" CACHE STRING "Roaring library version")
 set(ROARING_LIB_SOVERSION "0" CACHE STRING "Roaring library soversion")
 
 option(ROARING_DISABLE_X64 "Forcefully disable x64 optimizations even if hardware supports it (this disables AVX) " OFF)

## croaring 0.2.66%2Bds

=== tests/vendor/cmocka/CMakeLists.txt ===
add_library(cmocka STATIC cmocka.c)

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DROARING_DISABLE_NATIVE=ON

override_dh_auto_clean:
	dh_auto_clean $@
	rm -f tests/config.h

# Since we exclude realdata from archive, do not run ctest for it
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -- ARGS+="-E realdata_unit"
endif

## croaring 0.2.66+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -11,8 +11,8 @@
 set(ROARING_LIB_NAME roaring)
 set(PROJECT_VERSION_MAJOR 0)
 set(PROJECT_VERSION_MINOR 2)
-set(PROJECT_VERSION_PATCH 65)
-set(ROARING_LIB_VERSION "0.2.65" CACHE STRING "Roaring library version")
+set(PROJECT_VERSION_PATCH 66)
+set(ROARING_LIB_VERSION "0.2.66" CACHE STRING "Roaring library version")
 set(ROARING_LIB_SOVERSION "0" CACHE STRING "Roaring library soversion")
 
 option(ROARING_DISABLE_X64 "Forcefully disable x64 optimizations even if hardware supports it (this disables AVX) " OFF)

=== benchmarks/CMakeLists.txt ===
set (BENCHMARK_DATA_DIR "${CMAKE_CURRENT_SOURCE_DIR}/realdata/") # does this ever get used?

add_c_benchmark(create_benchmark)
add_c_benchmark(adversarialunions_benchmark)
# We exclude POSIX tests from Visual Studio default build
if(NOT WIN32)
    add_c_benchmark(real_bitmaps_benchmark)
    add_c_benchmark(real_bitmaps_contains_benchmark)
    add_c_benchmark(iteration_benchmark)
    add_c_benchmark(add_benchmark)
    target_link_libraries(add_benchmark m)
    add_c_benchmark(frozen_benchmark)
endif()
add_c_benchmark(bitset_container_benchmark)
add_c_benchmark(array_container_benchmark)
add_c_benchmark(run_container_benchmark)
add_c_benchmark(equals_benchmark)

=== tests/CMakeLists.txt ===
### This code is buggy because it does not ensure that all variables have been defined :
#set (TEST_DATA_DIR "${CMAKE_CURRENT_SOURCE_DIR}/testdata/")
#configure_file ("${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
#                "${CMAKE_CURRENT_SOURCE_DIR}/config.h")


add_cpp_test(cpp_unit)
add_c_test(array_container_unit)
add_c_test(bitset_container_unit)
add_c_test(mixed_container_unit)
add_c_test(run_container_unit)
add_c_test(toplevel_unit)
add_c_test(util_unit)
add_c_test(format_portability_unit)
add_c_test(robust_deserialization_unit)
add_c_test(container_comparison_unit)

if (NOT MSVC)
# We exclude POSIX tests from Visual Studio default build
add_c_test(realdata_unit)
# We used to exclude POSIX tests from Visual Studio default build the documented way but this leads to spurious test failures.
# set_target_properties(realdata_unit PROPERTIES EXCLUDE_FROM_DEFAULT_BUILD 1)
endif()


if(MSVC)
  add_custom_command(TARGET toplevel_unit POST_BUILD        # Adds a post-build event
    COMMAND ${CMAKE_COMMAND} -E echo "$<TARGET_FILE:roaring>"
    COMMAND ${CMAKE_COMMAND} -E echo "$<TARGET_FILE_DIR:toplevel_unit>"
    COMMAND ${CMAKE_COMMAND} -E copy_if_different  # which executes "cmake -E copy_if_different..."
        "$<TARGET_FILE:roaring>"      # <--this is in-file
        "$<TARGET_FILE_DIR:toplevel_unit>")                 # <--this is out-file path
endif()




add_subdirectory(vendor/cmocka)

=== debian/changelog ===
croaring (0.2.66+ds-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fixes for FTBFS with CMake 4. (Closes: #1112813)

 -- Adrian Bunk <bunk@debian.org>  Sun, 19 Oct 2025 13:23:50 +0300

croaring (0.2.66+ds-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1061909

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 17:43:31 +0000

croaring (0.2.66+ds-2) unstable; urgency=medium

  [ Simon McVittie ]
  * d/libroaring-dev.install: Do not override path of CMake metadata.
    The file varies between architectures, so /usr/share is not the right
    place for it. Moving it to a location with a different number of path
    segments also causes it to fail to find the library on non-merged-/usr
    systems. (Closes: #968063)
  * d/tests: Add a superficial compile/link/run autopkgtest

  [ Alexander Gerasiov ]
  * 001-containerptr_roaring_bitmap_add-public.patch: Add patch headers.
  * Backport 0002-Generate-and-install-pkg-config-metadata-235.patch from
    upstream (Closes: #968092).

 -- Alexander GQ Gerasiov <gq@debian.org>  Tue, 05 Jan 2021 15:44:54 +0300

croaring (0.2.66+ds-1) unstable; urgency=medium

  * New upstream version 0.2.66+ds

 -- Alexander GQ Gerasiov <gq@debian.org>  Sun, 03 May 2020 18:19:39 +0300

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: croaring
 Priority: optional
 Maintainer: Alexander GQ Gerasiov <gq@debian.org>
-Build-Depends: debhelper (>= 11), cmake
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper (>= 11), cmake
 Standards-Version: 4.3.0
 Section: libs
 Homepage: https://github.com/RoaringBitmap/CRoaring
@@ -10,7 +10,7 @@
 
 Package: libroaring-dev
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, libroaring0 (= ${binary:Version})
+Depends: ${misc:Depends}, libroaring0t64 (= ${binary:Version})
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: Portable Roaring bitmaps in C (and C++) (headers)
@@ -22,7 +22,10 @@
  .
  This package provides library headers.
 
-Package: libroaring0
+Package: libroaring0t64
+Provides: ${t64:Provides}
+Replaces: libroaring0
+Breaks: libroaring0 (<< ${source:Version})
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}

=== debian/tests/control ===
Tests: cmake
Depends: build-essential, cmake, libroaring-dev
Restrictions: superficial, allow-stderr

=== debian/watch ===
version=4

opts="dversionmangle=s/\+ds\d*$//,filenamemangle=s/(?:.*?)?v?(\d\S+)\.tar\.gz/CRoaring-$1.tar.gz/,repacksuffix=+ds,repack,compression=xz" \
   https://github.com/RoaringBitmap/CRoaring/tags \
   (?:.*?/)?v?(\d\S+)\.tar\.gz \
   debian
